#pragma once
#include<string>
#include "Struct.h"
#include<vector>
#include <set>
class MeshLoader {
public:
	virtual void LoadMesh(const std::string&) = 0;
	std::vector<Node>& GetNodes();
	std::vector<FiniteElement>& GetFE();
	std::vector<BoundaryFiniteElement>& GetBFE();
	void Print_Data();
	std::vector<FiniteElement> findFE(size_t ID1, size_t ID2, size_t ID3);
	std::vector<FiniteElement> findEdge(size_t ID1, size_t ID2);
	std::vector<Node> getSurfaceID(size_t ID);
	std::vector<std::set<size_t>>  GetNodesNeighbors();
	std::vector<Node> getMaterialID(size_t ID);
	std::vector<BoundaryFiniteElement> getBoundaryFiniteID(size_t ID);
	Node Get_Node_by_ID(size_t n_id);
	void InsertNewNodes();




protected:
	std::vector<Node> nodes;
	std::vector<FiniteElement> finiteElements;
	std::vector< BoundaryFiniteElement> boundaryFiniteElements;
};
